----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:59:32 04/24/2013 
-- Design Name: 
-- Module Name:    DOSI_U1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.ipbus.ALL;
use work.DOSI_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity DOSI_U2 is
    Port ( sysclk_p : in  STD_LOGIC;
           sysclk_n : in  STD_LOGIC;
					 GbE_RXN : in	STD_LOGIC;
					 GbE_RXP : in	STD_LOGIC;
					 GbE_TXN : out	STD_LOGIC;
					 GbE_TXP : out	STD_LOGIC;
					 SFP_LOS : in	STD_LOGIC;
					 SFP_ABS : in	STD_LOGIC;
					 TxFault : in	STD_LOGIC;
					 TxDisable : out	STD_LOGIC;
					 LINK_RXN : in	STD_LOGIC;
					 LINK_RXP : in	STD_LOGIC;
					 LINK_TXN : out	STD_LOGIC;
					 LINK_TXP : out	STD_LOGIC;
-- ADC DATA INPUT
					 DCLKDI_P : in	STD_LOGIC;
					 DCLKDI_N : in	STD_LOGIC;
           DI_P : in  STD_LOGIC_VECTOR (11 downto 0);
           DI_N : in  STD_LOGIC_VECTOR (11 downto 0);
					 DCLKDID_P : in	STD_LOGIC;
					 DCLKDID_N : in	STD_LOGIC;
           DID_P : in  STD_LOGIC_VECTOR (11 downto 0);
           DID_N : in  STD_LOGIC_VECTOR (11 downto 0);
					 DCLKDQ_P : in	STD_LOGIC;
					 DCLKDQ_N : in	STD_LOGIC;
           DQ_P : in  STD_LOGIC_VECTOR (11 downto 0);
           DQ_N : in  STD_LOGIC_VECTOR (11 downto 0);
					 DCLKDQD_P : in	STD_LOGIC;
					 DCLKDQD_N : in	STD_LOGIC;
           DQD_P : in  STD_LOGIC_VECTOR (11 downto 0);
           DQD_N : in  STD_LOGIC_VECTOR (11 downto 0);
--					 CALRUN : in	STD_LOGIC;
--					 PG_C2M : out	STD_LOGIC;
--					 PG_M2C : in	STD_LOGIC;
					 ORI_P : in	STD_LOGIC;
					 ORI_N : in	STD_LOGIC;
					 ORQ_P : in	STD_LOGIC;
					 ORQ_N : in	STD_LOGIC;
-- FLASH interface
           FLASH_S : out  STD_LOGIC;
           FLASH_D : out  STD_LOGIC;
           FLASH_Q : in  STD_LOGIC;
           FLASH_C : out  STD_LOGIC;
--
					 U1_INIT_B : in	STD_LOGIC;
					 U1_DONE : in	STD_LOGIC;
					 U1_CCLK : out	STD_LOGIC;
					 U1_CDATA : out	STD_LOGIC;
					 U1_PROG_B : out	STD_LOGIC;
					 U2_PROG_B : out	STD_LOGIC;
           LED : out  STD_LOGIC_VECTOR (5 downto 1);
           U2_T : out  STD_LOGIC_VECTOR (7 downto 0));
end DOSI_U2;

architecture Behavioral of DOSI_U2 is
COMPONENT ADC_if
	PORT(
		clk_p : IN std_logic;
		clk_n : IN std_logic;
		reset : IN std_logic;
		din_p : IN std_logic_vector(11 downto 0);
		din_n : IN std_logic_vector(11 downto 0);
		slip : IN std_logic;
		rdclk : IN std_logic;          
		clkout : OUT std_logic;
		dout : OUT std_logic_vector(95 downto 0)
		);
END COMPONENT;
COMPONENT ADC_buffer
	PORT(
		clk_div : IN std_logic;
		DIin : IN std_logic_vector(95 downto 0);
		DIDin : IN std_logic_vector(95 downto 0);
		DQin : IN std_logic_vector(95 downto 0);
		DQDin : IN std_logic_vector(95 downto 0);
		reset : IN std_logic;
		sample : IN std_logic;
		delay : IN array48x4;
		train : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_addr : IN std_logic_vector(31 downto 0);
		ipb_strobe : IN std_logic;
		ipb_write : IN std_logic;          
		train_waddr : OUT std_logic_vector(15 downto 0);
		train_done : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT GTP_if
	PORT(
		sysclk : IN std_logic;
		sysclk2x : IN std_logic;
		S6LinkGTPreset : IN std_logic;
		S6LinkCDRreset : IN std_logic;
		GbEGTPreset : IN std_logic;
		REFCLK_P : IN std_logic;
		REFCLK_N : IN std_logic;
		LINK_RXP : IN std_logic;
		LINK_RXN : IN std_logic;
		GbE_RXP : IN std_logic;
		GbE_RXN : IN std_logic;
		debug_in : IN std_logic_vector(31 downto 0);
		LINKtxdata : IN std_logic_vector(15 downto 0);
		LINKtxcharisk : IN std_logic_vector(1 downto 0);
		GbEtxdvld : IN std_logic;
		GbEtxd : IN std_logic_vector(7 downto 0);
		GbEtxdlast : IN std_logic;
		GbEtxerr : IN std_logic;          
		LINK_TXP : OUT std_logic;
		LINK_TXN : OUT std_logic;
		GbE_TXP : OUT std_logic;
		GbE_TXN : OUT std_logic;
		debug_out : OUT std_logic_vector(31 downto 0);
		LINKrxdata : OUT std_logic_vector(15 downto 0);
		Link_RXBYTEISALIGNED : OUT std_logic;
		LINKrxchariscomma : OUT std_logic_vector(1 downto 0);
		LINKrxcharisk : OUT std_logic_vector(1 downto 0);
		GbEtxready : OUT std_logic;
		GbErxd : OUT std_logic_vector(7 downto 0);
		GbErxdvld : OUT std_logic;
		GbErxdlast : OUT std_logic;
		GbErxerr : OUT std_logic;
		GTPCLKOUT : OUT std_logic;
		LINKpllLock : OUT std_logic
		);
END COMPONENT;
COMPONENT flash
	PORT(
		clk : IN std_logic;
		we : IN std_logic;
		strobe : IN std_logic;
		w_data : IN std_logic_vector(31 downto 0);
		addr : IN std_logic_vector(31 downto 0);
		MQ : IN std_logic;          
		flash_wdata : OUT std_logic_vector(31 downto 0);
		flash_rdata : OUT std_logic_vector(31 downto 0);
		flash_busy : OUT std_logic;
		MD : OUT std_logic;
		MCS : OUT std_logic_vector(1 downto 0)
		);
END COMPONENT;
COMPONENT LinkFIFO
  PORT (
    clk : IN STD_LOGIC;
    srst : IN STD_LOGIC;
    din : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
    wr_en : IN STD_LOGIC;
    rd_en : IN STD_LOGIC;
    dout : OUT STD_LOGIC_VECTOR(8 DOWNTO 0);
    full : OUT STD_LOGIC;
    empty : OUT STD_LOGIC
  );
END COMPONENT;
constant version : std_logic_vector(15 downto 0) := x"0001";
signal ipb_clk : std_logic := '0';
signal ipb_clk_n : std_logic := '0';
signal reset : std_logic := '0';
signal reset_ADCbuf : std_logic := '0';
signal rst_macclk : std_logic := '0';
signal clk_div : std_logic := '0';
signal ADC_reset : std_logic := '0';
signal sample : std_logic := '0';
signal train : std_logic := '0';
signal train_done : std_logic := '0';
signal delay : array48X4 := (others => x"0");
signal train_waddr : std_logic_vector(15 downto 0) := (others => '0');
signal slip : std_logic_vector(3 downto 0) := (others => '0');
signal DI_dout : std_logic_vector(95 downto 0) := (others => '0');
signal DID_dout : std_logic_vector(95 downto 0) := (others => '0');
signal DQ_dout : std_logic_vector(95 downto 0) := (others => '0');
signal DQD_dout : std_logic_vector(95 downto 0) := (others => '0');
signal ADC_data : std_logic_vector(31 downto 0) := (others => '0');
signal ORI : std_logic := '0';
signal ORQ : std_logic := '0';
signal ipb_master_out : ipb_wbus;
signal ipb_master_in : ipb_rbus;
signal rdata : std_logic_vector(31 downto 0) := (others => '0');
signal flash_busy : std_logic := '0';
signal flash_wdata : std_logic_vector(31 downto 0) := (others => '0');
signal flash_rdata : std_logic_vector(31 downto 0) := (others => '0');
signal rom_FAST_READ : std_logic := '0';
signal flash_md : std_logic := '0';
signal flash_mc : std_logic := '0';
signal flash_mcs : std_logic_vector(1 downto 0) := (others => '1');
signal sysclk_DCM_locked : std_logic := '0';
signal ipb_clk_dcm : std_logic := '0';
signal sysclk_dcm : std_logic := '0';
signal sysclk : std_logic := '0';
signal sysclk2x : std_logic := '0';
signal sysclk2x_dcm : std_logic := '0';
signal sysclk_in : std_logic := '0';
signal rst_sysclk_dcm : std_logic := '0';
signal rst_ipb : std_logic := '0';
signal div : std_logic_vector(3 downto 0) := (others =>'0');
signal sel_Link : std_logic := '0';
signal S6LinkGTPreset : std_logic := '0';
signal GbEGTPreset : std_logic := '0';
signal GTPclkOut : std_logic := '0';
signal LINKrxdata : std_logic_vector(15 downto 0) := (others =>'0');
signal LINKrxdata_q : std_logic_vector(7 downto 0) := (others =>'0');
signal LINKtxdata : std_logic_vector(15 downto 0) := (others =>'0');
signal LINKrxchariscomma : std_logic_vector(1 downto 0) := (others =>'0');
signal LINKrxcharisk : std_logic_vector(1 downto 0) := (others =>'0');
signal LINKrxcharisk1_q : std_logic := '0';
signal LINKtxcharisk : std_logic_vector(1 downto 0) := (others =>'0');
signal Link_RXBYTEISALIGNED : std_logic := '1';
signal LinkFIFO_rst : std_logic := '1';
signal LinkFIFO_wep : std_logic := '0';
signal LinkFIFO_we : std_logic := '0';
signal LinkFIFO_re : std_logic := '0';
signal LinkFIFO_empty : std_logic := '0';
signal LinkFIFO_din : std_logic_vector(8 downto 0) := (others =>'0');
signal LinkFIFO_dout : std_logic_vector(8 downto 0) := (others =>'0');
signal ipbus_txdvld : std_logic := '0';
signal ipbus_txready : std_logic := '0';
signal ipbus_txdlast : std_logic := '0';
signal ipbus_txerr : std_logic := '0';
signal ipbus_txd : std_logic_vector(7 downto 0) := (others =>'0');
signal GbEtxdvld : std_logic := '0';
signal GbEtxdlast : std_logic := '0';
signal GbEtxerr : std_logic := '0';
signal GbEtxready : std_logic := '0';
signal GbEtxack : std_logic := '0';
signal GbErxdlast : std_logic := '0';
signal GbErxerr : std_logic := '0';
signal GbErxdvld : std_logic := '0';
signal GbErxbadframe : std_logic := '0';
signal GbErxgoodframe : std_logic := '0';
signal GbEtxd : std_logic_vector(7 downto 0) := (others =>'0');
signal GbErxd : std_logic_vector(7 downto 0) := (others =>'0');
signal GbErxdvld_q : std_logic := '0';
signal GbErxbadframe_q : std_logic := '0';
signal GbErxgoodframe_q : std_logic := '0';
signal GbErxd_q : std_logic_vector(7 downto 0) := (others =>'0');
signal inh_conf : std_logic := '0';
signal en_conf : std_logic := '0';
signal en_CCLK : std_logic := '0';
signal en_flash_c : std_logic := '0';
signal M_Q : std_logic := '0';
signal U1_INIT_B_q : std_logic_vector(1 downto 0) := (others => '0');
signal conf_cntr : std_logic_vector(23 downto 0) := (others => '0');
signal reprogU1 : std_logic := '0';
signal reprogU1_dl : std_logic := '0';
signal prog_U1_b : std_logic := '0';
signal reprogU2 : std_logic := '0';
signal reprogU2_dl : std_logic := '0';
signal ADC_resetSyncReg : std_logic_vector(3 downto 0) := (others => '0');
signal reset_ADCbufSyncReg : std_logic_vector(3 downto 0) := (others => '0');
signal LED_i : std_logic_vector(4 downto 0) := (others => '0');
signal U2_T_i : std_logic_vector(7 downto 0) := (others => '0');
signal resetU1_n : std_logic := '0';
signal ipb_clk_toggle : std_logic := '0';
signal sysclk_toggle : std_logic := '0';
signal wr_amc_en : std_logic := '0';
signal amc_en : std_logic_vector(7 downto 0) := (others => '0');
signal RxU1cmd : std_logic := '0';
signal RxU1Cntr : std_logic_vector(2 downto 0) := (others => '0');
begin
LED <= LED_i;
U2_T <= U2_T_i;
--U1_INIT_B <= 'Z' when resetU1_n = '0' or U1_DONE = '0' else '0';
--LED <= (others => 'Z');
--U2_T <= (others => 'Z');
process(clk_div,ADC_reset)
begin
	if(ADC_reset = '1')then
		ADC_resetSyncReg <= x"f";
	elsif(clk_div'event and clk_div = '1')then
		ADC_resetSyncReg <= ADC_resetSyncReg(2 downto 0) & '0';
	end if;
end process;
process(clk_div,reset_ADCbuf)
begin
	if(reset_ADCbuf = '1')then
		reset_ADCbufSyncReg <= x"f";
	elsif(clk_div'event and clk_div = '1')then
		reset_ADCbufSyncReg <= reset_ADCbufSyncReg(2 downto 0) & '0';
	end if;
end process;
i_DI : ADC_if PORT MAP(
		clk_p => DCLKDI_P,
		clk_n => DCLKDI_N,
		reset => ADC_resetSyncReg(3),
		din_p => DI_P,
		din_n => DI_N,
		slip => slip(0),
		rdclk => clk_div,
		clkout => clk_div,
		dout => DI_dout
	);
i_DID : ADC_if PORT MAP(
		clk_p => DCLKDID_P,
		clk_n => DCLKDID_N,
		reset => ADC_resetSyncReg(3),
		din_p => DID_P,
		din_n => DID_N,
		slip => slip(1),
		rdclk => clk_div,
		clkout => open,
		dout => DID_dout
	);
i_DQ : ADC_if PORT MAP(
		clk_p => DCLKDQ_P,
		clk_n => DCLKDQ_N,
		reset => ADC_resetSyncReg(3),
		din_p => DQ_P,
		din_n => DQ_N,
		slip => slip(2),
		rdclk => clk_div,
		clkout => open,
		dout => DQ_dout
	);
i_DQD : ADC_if PORT MAP(
		clk_p => DCLKDQD_P,
		clk_n => DCLKDQD_N,
		reset => ADC_resetSyncReg(3),
		din_p => DQD_P,
		din_n => DQD_N,
		slip => slip(3),
		rdclk => clk_div,
		clkout => open,
		dout => DQD_dout
	);
i_ADC_buffer: ADC_buffer PORT MAP(
		clk_div => clk_div,
		DIin => DI_dout,
		DIDin => DID_dout,
		DQin => DQ_dout,
		DQDin => DQD_dout,
		reset => reset_ADCbufSyncReg(3),
		sample => sample,
		delay => delay,
		train => train,
		train_done => train_done,
		train_waddr => train_waddr,
		ipb_clk => ipb_clk,
		ipb_addr => ipb_master_out.ipb_addr,
		ipb_strobe => ipb_master_out.ipb_strobe,
		ipb_write => ipb_master_out.ipb_write,
		ipb_rdata => ADC_data
	);
process(ipb_clk,sysclk_DCM_LOCKED,reprogU1)
begin
	if(sysclk_DCM_LOCKED = '0' or reprogU1 = '1')then
		inh_conf <= '0';
		U1_INIT_B_q <= "00";
		en_conf <= '0';
		conf_cntr <= (others => '0');
		M_Q <= '0';
		FLASH_D <= '0';
		U1_CDATA <= '0';
		en_CCLK <= '0';
	elsif(ipb_clk'event and ipb_clk = '1')then
		if(prog_U1_b = '0')then
			inh_conf <= '0';
		elsif(en_conf = '1')then
			inh_conf <= '1';
		end if;
		U1_INIT_B_q <= U1_INIT_B_q(0) & U1_INIT_B;
		if(U1_DONE = '0' and U1_INIT_B_q = "01" and inh_conf = '0')then
			en_conf <= '1';
		elsif(conf_cntr(23 downto 22) = "11")then
			en_conf <= '0';
		end if;
		if(en_conf = '0')then
			conf_cntr <= (others => '0');
		else
			conf_cntr <= conf_cntr + 1;
		end if;
		M_Q <= FLASH_Q;
		if(en_conf = '0')then
			FLASH_D <= flash_MD;
		elsif(or_reduce(conf_cntr(23 downto 5)) = '0')then
			FLASH_D <= rom_FAST_READ;
			U1_CDATA <= '0';
		else
			FLASH_D <= '0';
			U1_CDATA <= M_Q;
		end if;
		FLASH_S <= not en_conf and (not flash_MCS(1) and not flash_MCS(0));
		if(en_conf = '0')then
			en_CCLK <= '0';
		elsif(conf_cntr(5) = '1' and conf_cntr(3) = '1' and conf_cntr(1) = '1')then
			en_CCLK <= '1';
		end if;
	end if;
end process;
en_FLASH_C <= en_conf or flash_MCS(1);
ipb_clk_n <= not ipb_clk;
i_U1_CCLK_ddr : ODDR2
   port map (
      Q => U1_CCLK, -- 1-bit output data
      C0 => ipb_clk, -- 1-bit clock input
      C1 => ipb_clk_n, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '0',   -- 1-bit data input (associated with C0)
      D1 => en_CCLK,   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
i_FLASH_C_ddr : ODDR2
   port map (
      Q => FLASH_C, -- 1-bit output data
      C0 => ipb_clk, -- 1-bit clock input
      C1 => ipb_clk_n, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '0',   -- 1-bit data input (associated with C0)
      D1 => en_FLASH_C,   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
i_rom_FAST_READ : ROM32X1
   generic map (
      INIT => X"000002d0") -- fast read start at 0x400000
   port map (
      O => rom_FAST_READ,   -- ROM output
      A0 => conf_cntr(0), -- ROM address[0]
      A1 => conf_cntr(1), -- ROM address[1]
      A2 => conf_cntr(2), -- ROM address[2]
      A3 => conf_cntr(3), -- ROM address[3]
      A4 => conf_cntr(4)  -- ROM address[4]
   );
i_flash: flash PORT MAP(
		clk => ipb_clk,
		we => ipb_master_out.ipb_write,
		strobe => ipb_master_out.ipb_strobe,
		w_data => ipb_master_out.ipb_wdata,
		addr => ipb_master_out.ipb_addr,
		flash_wdata => flash_wdata,
		flash_rdata => flash_rdata,
		flash_busy => flash_busy,
		MQ => FLASH_Q,
		MD => flash_MD,
		MCS => flash_MCS
	);
i_ipb_clkBUFG : BUFG
   port map (
      O => ipb_clk, -- 1-bit output: Clock buffer output
      I => ipb_clk_dcm  -- 1-bit input: Clock buffer input
   );
i_sysclkBUFG : BUFG
   port map (
      O => sysclk, -- 1-bit output: Clock buffer output
      I => sysclk_dcm  -- 1-bit input: Clock buffer input
   );
i_sysclk2xBUFG : BUFG
   port map (
      O => sysclk2x, -- 1-bit output: Clock buffer output
      I => sysclk2x_dcm  -- 1-bit input: Clock buffer input
   );
i_sysclkBUFIO2 : BUFIO2
   generic map (
      DIVIDE => 1,           -- DIVCLK divider (1-8)
      DIVIDE_BYPASS => TRUE, -- Bypass the divider circuitry (TRUE/FALSE)
      I_INVERT => FALSE,     -- Invert clock (TRUE/FALSE)
      USE_DOUBLER => FALSE   -- Use doubler circuitry (TRUE/FALSE)
   )
   port map (
      DIVCLK => sysclk_in,             -- 1-bit output: Divided clock output
      IOCLK => open,               -- 1-bit output: I/O output clock
      SERDESSTROBE => open, -- 1-bit output: Output SERDES strobe (connect to ISERDES2/OSERDES2)
      I => GTPCLKOUT                        -- 1-bit input: Clock input (connect to IBUFG)
   );
i_sysclk_dcm : DCM_SP
    generic map
    (
        CLKDV_DIVIDE          =>          4.0,
        CLKIN_DIVIDE_BY_2     =>          false,
				CLKFX_DIVIDE 					=> 					16,                     -- Divide value on CLKFX outputs - D - (1-32)
				CLKFX_MULTIPLY 				=> 					2,                   -- Multiply value on CLKFX outputs - M - (2-32)
        CLK_FEEDBACK          =>          "1X"
    )    
    port map
    (
        CLK0                =>          sysclk_dcm,
        CLK180              =>          open,
        CLK270              =>          open,
        CLK2X               =>          sysclk2x_dcm,
        CLK2X180            =>          open,
        CLK90               =>          open,
        CLKDV               =>          ipb_clk_dcm,
        CLKFX               =>          open,
        CLKFX180            =>          open,
        PSDONE              =>          open,
        STATUS              =>          open,
        DSSEN               =>          '0',
        PSCLK               =>          '0',
        PSEN                =>          '0',          
        PSINCDEC            =>          '0',      
        LOCKED              =>          sysclk_DCM_LOCKED,
        CLKFB               =>          sysclk,
        CLKIN               =>          sysclk_in,
        RST                 =>          rst_sysclk_dcm
    );
--rst_sysclk_dcm <= not LINKPLLLOCK;
rst_sysclk_dcm <= '0';
--S6LinkGTPreset <= not U1_DONE;
S6LinkGTPreset <= conf_cntr(23);
--GbEGTPreset <= conf_cntr(26);
--GbEGTPreset <= en_conf;
GbEGTPreset <= conf_cntr(23);
i_GTP_if: GTP_if PORT MAP(
		sysclk => sysclk,
		sysclk2x => sysclk2x,
		S6LinkGTPreset => S6LinkGTPreset,
		S6LinkCDRreset => en_conf,
		GbEGTPreset => GbEGTPreset,
		REFCLK_P => sysclk_p,
		REFCLK_N => sysclk_n,
		LINK_RXP => LINK_RXP,
		LINK_RXN => LINK_RXN,
		GbE_RXP => GbE_RXP,
		GbE_RXN => GbE_RXN,
		LINK_TXP => LINK_TXP,
		LINK_TXN => LINK_TXN,
		GbE_TXP => GbE_TXP,
		GbE_TXN => GbE_TXN,
		LINKtxdata => LINKtxdata,
		LINKtxcharisk => LINKtxcharisk,
		LINKrxdata => LINKrxdata,
		LINKrxchariscomma => LINKrxchariscomma,
		LINKrxcharisk => LINKrxcharisk,
		Link_RXBYTEISALIGNED => Link_RXBYTEISALIGNED,
		GbEtxdvld => GbEtxdvld,
		GbEtxd => GbEtxd,
		GbEtxdlast => GbEtxdlast,
		GbEtxerr => GbEtxerr,
		GbEtxready => GbEtxready,
		GbErxd => GbErxd,
		GbErxdvld => GbErxdvld,
		GbErxdlast => GbErxdlast,
		GbErxerr => GbErxerr,
		debug_in => (others => '0'),
		debug_out => open,
		GTPCLKOUT => GTPCLKOUT,
		LINKPLLLOCK => open
	);
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
--		sysclk_toggle <= not sysclk_toggle;
		GbErxd_q <= GbErxd;
		GbErxdvld_q <= GbErxdvld;
		GbErxgoodframe <= GbErxdvld and GbErxdlast and not GbErxerr;
		GbErxbadframe <= GbErxdvld and GbErxdlast and GbErxerr;
		GbErxgoodframe_q <= GbErxgoodframe;
		GbErxbadframe_q <= GbErxbadframe;
		if(GbErxdvld_q = '1')then
			LINKtxcharisk(0) <= '0';
			LINKtxdata(7 downto 0) <= GbErxd_q;
		elsif(GbErxgoodframe_q = '1')then
			LINKtxcharisk(0) <= '1';
			LINKtxdata(7 downto 0) <= x"f7";
		elsif(GbErxbadframe_q = '1')then
			LINKtxcharisk(0) <= '1';
			LINKtxdata(7 downto 0) <= x"fb";
		elsif(GbErxdvld = '1')then
			LINKtxcharisk(0) <= '1';
			LINKtxdata(7 downto 0) <= x"3c";
		elsif(div(3) = '1')then
			LINKtxcharisk(0) <= '1';
			LINKtxdata(7 downto 0) <= x"bc";
		else
			LINKtxcharisk(0) <= '0';
			LINKtxdata(7 downto 0) <= x"00";
		end if;
		if(div(3) = '1' or GbErxdvld_q = '1')then
			div <= (others => '0');
		else
			div <= div + 1;
		end if;
		if((GbEtxdlast = '1' and sel_Link = '1') or (LinkFIFO_empty = '1' and GbErxdvld = '1' and GbErxdvld_q = '0'))then
			LINKtxcharisk(1) <= '1';
			LINKtxdata(15 downto 8) <= x"f7";
		else
			LINKtxcharisk(1) <= '0';
			LINKtxdata(15 downto 8) <= x"00";
		end if;
		if(U1_Done = '0' or LinkFIFO_rst = '1')then
			sel_Link <= '0';
		elsif(GbEtxdvld = '0')then
			sel_Link <= not LinkFIFO_empty;
		end if;
		if(U1_Done = '0' or LinkFIFO_rst = '1')then
			LinkFIFO_wep <= '0';
			LinkFIFO_we <= '0';
		elsif(LINKrxcharisk(0) = '1')then
			if(LINKrxdata(7 downto 0) = x"3c")then
				LinkFIFO_wep <= '1';
			else
				LinkFIFO_wep <= '0';
				LinkFIFO_we <= '0';
			end if;
		else
			LinkFIFO_we <= LinkFIFO_wep;
		end if;
		LinkFIFO_din(7 downto 0) <= LINKrxdata(7 downto 0);
		LINKrxcharisk1_q <= LINKrxcharisk(1);
		LINKrxdata_q <= LINKrxdata(15 downto 8);
		if(U1_Done = '0')then
			RxU1cmd <= '0';
		elsif(LINKrxcharisk1_q = '1')then
			if(LINKrxdata_q = x"fe")then
				RxU1cmd <= '1';
			else
				RxU1cmd <= '0';
			end if;
		end if;
		if(RxU1cmd = '0')then
			RxU1Cntr <= (others => '0');
		else
			RxU1Cntr <= RxU1Cntr + 1;
		end if;
		if(RxU1cmd = '0')then
			wr_amc_en <= '0';
--			rst_ipbus <= '0';
		elsif(or_reduce(RxU1Cntr) = '0')then
			if(LINKrxdata_q = x"a5")then
				wr_amc_en <= '1';
--			elsif(LINKrxdata_q = x"38")then
--				rst_ipbus <= '1';
			end if;
		end if;
		if(wr_amc_en = '1')then
			amc_en <= LINKrxdata_q;
		end if;
		LinkFIFO_rst <= not Link_RXBYTEISALIGNED or not U1_Done;
	end if;
end process;
GbEtxd <= LinkFIFO_dout(7 downto 0) when sel_Link = '1' else ipbus_txd;
GbEtxdvld <= not LinkFIFO_empty when sel_Link = '1' else ipbus_txdvld;
GbEtxdlast <= LinkFIFO_dout(8) when sel_Link = '1' else ipbus_txdlast;
--GbEtxerr <= LinkFIFO_dout(9) when sel_Link = '1' else ipbus_txerr;
GbEtxerr <= '0' when sel_Link = '1' else ipbus_txerr;
LinkFIFO_re <= GbEtxready and sel_Link;
ipbus_txready <= GbEtxready and not sel_Link;
-- this is a first word fall through FIFO with synchronous reset
i_LinkFIFO : LinkFIFO
  PORT MAP (
    clk => sysclk,
    srst => LinkFIFO_rst,
    din => LinkFIFO_din,
    wr_en => LinkFIFO_we,
    rd_en => LinkFIFO_re,
    dout => LinkFIFO_dout,
    full => open,
    empty => LinkFIFO_empty
  );
LinkFIFO_din(8) <= LINKrxcharisk(0);
rst_ipb <= conf_cntr(23);
rst_macclk <= conf_cntr(23);
i_ipbus: entity work.ipbus_ctrl port map(
		mac_clk => sysclk,
		rst_macclk => rst_macclk,
		ipb_clk => ipb_clk,
		rst_ipb => rst_ipb,
		mac_rx_data => GbErxd,
		mac_rx_valid => GbErxdvld,
		mac_rx_last => GbErxdlast,
		mac_rx_error => GbErxerr,
		mac_tx_data => ipbus_txd,
		mac_tx_valid => ipbus_txdvld,
		mac_tx_last => ipbus_txdlast,
		mac_tx_error => ipbus_txerr,
		mac_tx_ready => ipbus_txready,
		ipb_out => ipb_master_out,
		ipb_in => ipb_master_in,
		mac_addr => x"080030f30123",
		ip_addr => x"c0a8019a"
	);
i_prog_U1_b : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => prog_U1_b,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CE => '1',  -- Clock enable input
      CLK => ipb_clk,   -- Clock input
      D => sysclk_DCM_LOCKED        -- SRL data input
   );
U1_PROG_B <= prog_U1_b and not reprogU1;
process(ipb_master_in,flash_wdata,flash_rdata,rdata)
begin
	if(ipb_master_out.ipb_addr(17) = '1')then
		ipb_master_in.ipb_rdata <= ADC_data;
	elsif(ipb_master_out.ipb_addr(12) = '1')then
		if(ipb_master_out.ipb_addr(7) = '0')then
			ipb_master_in.ipb_rdata <= flash_wdata;
		else
			ipb_master_in.ipb_rdata <= flash_rdata;
		end if;
	else
		ipb_master_in.ipb_rdata <= rdata;
	end if;
end process;
TxDisable <= TxFault;
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
--		ipb_clk_toggle <= not ipb_clk_toggle;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0000" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			reset <= ipb_master_out.ipb_wdata(0);
			reset_ADCbuf <= ipb_master_out.ipb_wdata(2);
			ADC_reset <= ipb_master_out.ipb_wdata(3);
			reprogU1 <= ipb_master_out.ipb_wdata(4);
			reprogU2 <= ipb_master_out.ipb_wdata(8);
			train <= ipb_master_out.ipb_wdata(12);
			sample <= ipb_master_out.ipb_wdata(13);
		else
			reset <= '0';
			reset_ADCbuf <= '0';
			ADC_reset <= '0';
			train <= '0';
			sample <= '0';
			if(reprogU1_dl = '1')then
				reprogU1 <= '0';
			end if;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0008" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			U2_T_i <= ipb_master_out.ipb_wdata(7 downto 0);
			LED_i <= not ipb_master_out.ipb_wdata(12 downto 8);
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0010" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0011" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+6) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0012" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+12) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0013" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+18) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0014" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+24) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0015" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+30) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0016" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+36) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0017" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			for i in 0 to 5 loop
				delay(i+42) <= ipb_master_out.ipb_wdata(i*4+3 downto i*4);
			end loop;
		end if;
		if(ipb_master_out.ipb_addr(15 downto 0) = x"0018" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			slip <= ipb_master_out.ipb_wdata(3 downto 0);
		elsif(ipb_master_in.ipb_ack = '1')then
			slip <= x"0";
		end if;
		if(ipb_master_out.ipb_addr(4) = '0')then
			case ipb_master_out.ipb_addr(3 downto 0) is
				when x"0" => rdata <= version & x"000" & '0' & TxFault & SFP_LOS & SFP_ABS;
				when x"1" => rdata <= x"0000000" & "000" & flash_busy;
				when x"3" => rdata <= U1_INIT_B & not U1_DONE & ORI & ORQ & x"0000000";
				when x"8" => rdata <= x"0000" & "000" & LED_i & U2_T_i;
				when others => rdata <= (others => '0');
			end case;
		else
			case ipb_master_out.ipb_addr(3 downto 0) is
				when x"0" => rdata <= x"00" & delay(5) & delay(4) & delay(3) & delay(2) & delay(1) & delay(0);
				when x"1" => rdata <= x"00" & delay(11) & delay(10) & delay(9) & delay(8) & delay(7) & delay(6);
				when x"2" => rdata <= x"00" & delay(17) & delay(16) & delay(15) & delay(14) & delay(13) & delay(12);
				when x"3" => rdata <= x"00" & delay(23) & delay(22) & delay(21) & delay(20) & delay(19) & delay(18);
				when x"4" => rdata <= x"00" & delay(29) & delay(28) & delay(27) & delay(26) & delay(25) & delay(24);
				when x"5" => rdata <= x"00" & delay(35) & delay(34) & delay(33) & delay(32) & delay(31) & delay(30);
				when x"6" => rdata <= x"00" & delay(41) & delay(40) & delay(39) & delay(38) & delay(37) & delay(36);
				when x"7" => rdata <= x"00" & delay(47) & delay(46) & delay(45) & delay(44) & delay(43) & delay(42);
--				when x"8" => rdata <= x"0000000" & slip;
				when x"9" => rdata <= x"000" & "000" & train_done & train_waddr;
				when x"a" => rdata <= x"000000" & amc_en;
				when others => rdata <= (others => '0');
			end case;
		end if;
		ipb_master_in.ipb_ack <= ipb_master_out.ipb_strobe;
	end if;
end process;
ipb_master_in.ipb_err <= '0';	
U2_PROG_B <= not reprogU2_dl;
i_reprogU1_dl : SRLC32E
   generic map (
      INIT => X"00000000")
   port map (
      Q => reprogU1_dl,        -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => "11111",        -- 5-bit shift depth select input
      CE => '1',      -- Clock enable input
      CLK => ipb_clk,    -- Clock input
      D => reprogU1         -- SRL data input
   );
i_reprogU2_dl : SRLC32E
   generic map (
      INIT => X"00000000")
   port map (
      Q => reprogU2_dl,        -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => "11111",        -- 5-bit shift depth select input
      CE => '1',      -- Clock enable input
      CLK => ipb_clk,    -- Clock input
      D => reprogU2         -- SRL data input
   );
i_ORI : IBUFDS generic map (IOSTANDARD => "LVDS_33") port map (I => ORI_P, IB => ORI_N, O => ORI);
i_ORQ : IBUFDS generic map (IOSTANDARD => "LVDS_33") port map (I => ORQ_P, IB => ORQ_N, O => ORQ);
i_resetU1_n : SRLC32E
   generic map (
      INIT => X"00000000")
   port map (
      Q => resetU1_n,        -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => "11111",        -- 5-bit shift depth select input
      CE => '1',      -- Clock enable input
      CLK => ipb_clk,    -- Clock input
      D => U1_DONE         -- SRL data input
   );

end Behavioral;

